"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var tslib_1 = require("tslib");
var core_1 = require("@taro-hooks/core");
var shared_1 = require("@taro-hooks/shared");
var useDebounceFn_1 = tslib_1.__importDefault(require("../useDebounceFn"));
function useDebounce(value, options) {
  var _ref = (0, core_1.useState)(value),
    debounced = _ref[0],
    setDebounced = _ref[1];
  var debounceFn = (0, useDebounceFn_1["default"])(function () {
    setDebounced(value);
  }, options);
  (0, core_1.useEffect)(function () {
    (0, shared_1.escapeState)(debounceFn).run();
  }, [value]);
  return debounced;
}
exports["default"] = useDebounce;