"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var tslib_1 = require("tslib");
var core_1 = require("@taro-hooks/core");
var useLatest_1 = tslib_1.__importDefault(require("../useLatest"));
var shared_1 = require("@taro-hooks/shared");
var useUnmount = function useUnmount(fn) {
  if (process.env.NODE_ENV === 'development') {
    if (!(0, shared_1.isFunction)(fn)) {
      console.error("useUnmount expected parameter is a function, got " + typeof fn);
    }
  }
  var fnRef = (0, useLatest_1["default"])(fn);
  (0, core_1.useEffect)(function () {
    return function () {
      fnRef == null ? void 0 : fnRef.current == null ? void 0 : fnRef.current();
    };
  }, []);
};
exports["default"] = useUnmount;